/*  -*- c++ -*- */
/* src.lex */

%{
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "tok.h"
  // int yyerror(char *s);
int num_comments=0;
%}

%x COMMENT
%x COMMENT2

letter [a-zA-Z]
digit [0-9]
int_constant {digit}+
identifier {letter}({digit}|{letter}|[_])*
whitespace [ \t\n]

%%

"class"   {return CLASS;}
"public"  {return PUBLIC;}
"static"  {return STATIC;}
"void"    {return VOID;}
"main"    {return MAIN;}
"string"  {return STRING;}
"int"     {return INT;}
"boolean" {return BOOLEAN;}
"if"      {return IF;}
"else"    {return ELSE;}
"while"   {return WHILE;}
"system"  {return SYSTEM;}
"out"     {return OUT;}
"println" {return PRINTLN;}
"length"  {return LENGTH;}
"true"    {return TRUE;}
"false"   {return FALSE;}
"this"    {return THIS;}
"new"     {return NEW;}
"extends" {return EXTENDS;}
"return"  {return RETURN;}
"("       {return '(';}
")"       {return ')';}
"+"       {return '+';}
"-"       {return '-';}
"*"       {return '*';}
"/"       {return '/';}
"="       {return '=';}
"<"       {return '<';}
"."       {return '.';}
","       {return ',';}
"{"       {return '{';}
"}"       {return '}';}
";"       {return ';';}
"["       {return '[';}
"]"       {return ']';}
"!"       {return '!';}

"/*" {num_comments++; BEGIN(COMMENT);}
"//" {BEGIN(COMMENT2);}

{int_constant}    {//yylval.int_val = atoi(yytext);
                   }
{whitespace}+ {}
{identifier}  {//yylval.id = malloc(strlen(yytext)+1);
               //strcpy(yylval.id, yytext);
              return ID;}

.             {printf ("%s", "ERROR");// yyerror(yytext); 
                exit(1);}

<COMMENT>"/*" {num_comments++;}
<COMMENT>"*/" {num_comments--;if(num_comments==0){BEGIN(0);}}
<COMMENT>. 

<COMMENT2>\n {BEGIN(0);}
<COMMENT2>. 

%%

/*
int main(){
  yylex();

}
*/

/* int yyerror( string s) {  // error handler routine */
/* /\*   extern int  yylineno;    // defined and maintained in lex.c *\/ */
/* /\*   extern char* yytext;     // defined and maintained in lex.c *\/ */
/* /\*   cerr << "ERROR: " << s << " at symbol " << yytext; *\/ */
/* /\*   cerr << " on line " << yylineno << endl; *\/ */
/* /\*   exit(1); *\/ */
/* } */

// int yyerror( char* s ) { }
